/*!
=====================================

MetroTab by SONHLAB.com - version 2.1 - 20130503
website: http://sonhlab.com
Documentation: http://docs.sonhlab.com/metrotab-responsive-metro-ui-tabs/

=====================================
*/

(function($){

	var MetroTabs = function(e, options){
	
		//Default settings
		var settings = $.extend({}, $.fn.metrotabs.defaults, options);
		
		var $viewWidth;
		var $blockholderWidth;
		var $blockholderHeight;
		var $contentWidth;
		var $mtcontent;
		var MoveOut;
		var MoveIn;
		var $filepath;
		var $click=0;
		var $scrollapi;
		
		
		
		// Set Params
		if ( settings.moveout == 'TopOrLeft' ) {
			MoveOut = '-1000px';
		}
		else if ( settings.moveout == 'BottomOrRight' ) {
			MoveOut = '1000px';
		}

		if ( settings.movein == 'TopOrLeft' ) {
			MoveIn = '-1000px';
		}
		else if ( settings.movein == 'BottomOrRight' ) {
			MoveIn = '1000px';
		}

		// Set style for Scroll Bar 
		if ( settings.scrollbarstyle != null ) {
			var ScrollBarStyle = settings.scrollbarstyle;}
		
		// create the direction object
		var objDirectionIn = {};
		var objDirectionOut = {};
		var objDirectionReset = {};
		var Direction;
		if ( settings.mtEffect == 'vertical' ) {
			objDirectionOut['top'] = MoveOut;
			objDirectionIn['top'] = MoveIn;
			objDirectionReset['top'] = 0;
		}
		else if ( settings.mtEffect == 'horizontal' ) {
			objDirectionOut['left'] = MoveOut;
			objDirectionIn['left'] = MoveIn;
			objDirectionReset['left'] = 0;
		}
		else if ( settings.mtEffect == 'fade' ) {
			objDirectionOut['opacity'] = 0;
			objDirectionIn['opacity'] = 0;
			objDirectionReset['opacity'] = 1;
		}
		
		
		
		
		// Call Masonry function
		var $msr = 0;
		function callMasonry() {
			//  Dynamic Grid use Masonry Plugin
			$(e).find('.mt-blocksholder').masonry({
			  itemSelector: '.mt-tab',
			  columnWidth: 100,
			  isResizable: true,
			  isAnimated: !Modernizr.csstransitions
			});
			$msr = 1;
		}
		// End CallMasonry


		
		
		// ClickTab Function
		function mtClickTab($tabid) {
		
			
				// Check active status of the clicked tab
				if ( ! $($tabid).hasClass('mt-active') ) {
				
					// Get content file name to load
					$mtcontent = $($tabid).attr('id');
					
					// Reset active tab
					$(e).find(".mt-loadcontent").removeClass("mt-active");
						
					// Determine the active tab
					$($tabid).addClass("mt-active");
					
					// Disable click effect when content is loading
					$(e).find('.mt-loadcontent').toggleClass('mt-loadcontent mt-loadingcontent');
					

					// Slide Effects
					$(e).find(settings.ContentBlock).animate(
						objDirectionOut,
						settings.outduration,
						settings.outeffect,
						function() {
						
							// Set new position for content
							$(this).css(objDirectionIn);
						
							// Remove current content
							if ($viewWidth < 800 ) {
								$(e).find(settings.ContentBlock).contents().remove();
							}
							else {
								$(e).find(settings.ContentBlock).find('.jspContainer').find('.jspPane').contents().remove();
							}
				
						// Load new content
						if ( $("div[data-mtid='"+ $mtcontent +"']").length > 0 ) {
							if ( $viewWidth < 800 ) {
								$("div[data-mtid='"+ $mtcontent +"']").contents().clone().appendTo($(e).find(settings.ContentBlock));
							}
							else {
								$("div[data-mtid='"+ $mtcontent +"']").contents().clone().appendTo($(e).find(settings.ContentBlock).find('.jspContainer').find('.jspPane'));
							}
							
							
							// Show Content With Effect
							$(e).find(settings.ContentBlock).animate(
								objDirectionReset,
								settings.induration,
								settings.ineffect,
								function() {
									// Enable click effect after content loaded
									$(e).find('.mt-loadingcontent').toggleClass('mt-loadcontent mt-loadingcontent');
									// Responsive Video
									resMedia();
								}
							);
							// End Show Content with Effect
							
						}
						else { // If Content not exist in station
						
							// Prepare content package holder
							$('#mt-station').append("<div data-mtid='"+$mtcontent+"'></div>");
										
							// New content file
							$filepath = 'content/'+$mtcontent+'.'+settings.mtFileExtension;
							
							// Load new content
							$.ajax({
								url: $filepath,
								type:'POST',
								cache: false,
								success: function(mtcontent){
									if (mtcontent) {
										if ( $("div[data-mtid='"+$mtcontent+"']").length > 0 ) {
										
											// Store content
											$("div[data-mtid='"+ $mtcontent +"']").append(mtcontent);
														
											// Show content
											if ( $viewWidth < 800 ) {
												$("div[data-mtid='"+ $mtcontent +"']").contents().clone().appendTo($(e).find(settings.ContentBlock));
											}
											else {
												$("div[data-mtid='"+ $mtcontent +"']").contents().clone().appendTo($(e).find(settings.ContentBlock).find('.jspContainer').find('.jspPane'));
											}
											
											// Show Content With Effect
											$(e).find(settings.ContentBlock).animate(
												objDirectionReset,
												settings.induration,
												settings.ineffect,
												function() {
													// Enable click effect after content loaded
													$('.mt-loadingcontent').toggleClass('mt-loadcontent mt-loadingcontent');
													// Responsive Video
													resMedia();
												}
											);
											// End Show Content with Effect

										}
									}
								},
								error: function(mtcontent) {
									alert('Error: Content not exist!');
									$(e).find('.mt-loadingcontent').toggleClass('mt-loadcontent mt-loadingcontent');
								}
							});
							// End Ajax
							
						}
						// End Load Content
					
					});
					// End Slide Effects
					
				}
				// End If Tab is not active
		
		}
		// End Function mtClickTab()
		

		/* Responsive Media */
		function resMedia() {
			$(e).find(settings.ContentBlock).find('.video-holder').each(function($i){
				
				var $initparentWidth=new Array();
				var $videoWidth=new Array();
				var $videoHeight=new Array();
				
				// Get Video Holder Block Width
				$initparentWidth[$i] = $(e).find(settings.ContentBlock).find('.video-holder').eq($i).parent().width();

				$videoWidth[$i] = $initparentWidth[$i];
				
				$videoHeight[$i] = $videoWidth[$i]*9/16;

				// Set Video Height
				$(e).find(settings.ContentBlock).find('.video-holder').eq($i).css({'height':$videoHeight[$i]+'px'});

			}); // End each

		}
		/* End Responsive Media */
		
		
		
		// Prepare MetroTab Station
		if ( ! $('#mt-station').length ) {
			$('body').append("<div id='mt-station'></div>");
			$('#mt-station').css({'display':'none'});
		}
		
		
		
		// Render Metro Tabs
		function mtRender() {
			
			// MetroTab Width
			$viewWidth = $(e).width();
			
			// Destroy Mansory function
			if ( $msr == 1 ) {
				$(e).find('.mt-blocksholder').masonry('destroy');
				$msr = 0;
			}
			
			// MetroTabs < 800px
			if ( $viewWidth < 800 ) {
	
				$(e).find('.mt-blocksholder').css({'display':'none','width':$viewWidth-10+'px'});
				
				$(e).find('.mt-contentblockstyle').css({'display':'block','padding':'10px'});
				
				$(e).find(settings.ContentBlock).css({'height':'auto'});
				
				// Create minibar
				$(e).find('.mt-blocksholder').before("<div class='mt-minibar "+settings.minibarbg+"'><img src='images/metrotab/mt-icon.png' alt='metrotab' /><span>"+settings.minibartitle+"</span><img src='images/metrotab/rightarrow.png' class='floatright' alt='show metrotab' /></div>");
				
				$(e).find('.mt-minibar').on('click',
				function(){
					if ( $click == 0 ) {
						
						$(e).find('.mt-contentblock').css({'display':'none'});
						
						$(e).find('.mt-blocksholder').fadeIn(200,
						function(){

							$click = 1;
							
							// Click on Tabs
							$(e).find('.mt-blocksholder').find('.mt-loadcontent').on("click",
							function() {
								if ( $viewWidth < 800 ) {
								
									// Call Click Tab Function
									mtClickTab(this);
									
									$(e).find('.mt-blocksholder').css({'display':'none'});
									$(e).find('.mt-contentblock').fadeIn(200,
									function(){
										// Reset $click;
										$click=0;
									});
								}
					
							});
							// End Click on Tabs
							
							
						});
					}
					else {
						$(e).find('.mt-blocksholder').css({'display':'none'});
						$(e).find('.mt-contentblock').fadeIn(200, function(){$click=0;});
					}
				});
				
				// Call Masonry function
				callMasonry();
			
			
			}
			// End ViewWidth < 800
			
			else { // ViewWidth >=800
				
				// Show Block Holder
				$(e).find('.mt-blocksholder').css({'display':'block','width':settings.blkwidth+'px'});
				
				// Show Content Block
				$(e).find('.mt-contentblock').css({'display':'block','padding':'5px'});
				
				// Call Masonry function
				callMasonry();
				
				// Block Holder Width
				$blockholderWidth = $(e).find('.mt-blocksholder').width();
				
				// Content Block Width
				$contentWidth = $viewWidth - $blockholderWidth - 10;
				
				// Content Block Height
				$contentHeight = $(e).find('.mt-blocksholder').height() - 10;
				
				// Set Style for Content Block
				$(e).find('.mt-contentblock').css({'height':$contentHeight+'px', 'width':$contentWidth+'px'});
				$(e).find(settings.ContentBlock).css({'height':$contentHeight+'px'});
				
				// Style for Content
				$(e).find(settings.ContentBlock).children().css({'width':'auto'});
				
				// Click on Tabs
				$(e).find('.mt-blocksholder').find('.mt-loadcontent').on("click",
				function() {
					
					if ( $viewWidth >= 800 ) {
						// Call Click Tab Function
						mtClickTab(this);
					}
					
				});
				// End Click on Tabs
				
			}
			// End viewWidth >=800

		}
		// End Render Metro Tabs Function
		
	
		// Render MetroTabs Plugin
		mtRender();
		
		
		
		// Check default content
		var $dfcontent = $(e).find(".mt-active:first").attr("id");
		// Load Default Content
		if ( ! $('#mt-station').find("div[data-mtid='"+ $dfcontent +"']").length ) {
			
			// Prepare content package holder
			$('#mt-station').append("<div data-mtid='"+$dfcontent+"'></div>");
			
			// Default content file
			$filepath = 'content/'+$dfcontent+'.'+settings.mtFileExtension;
			
			$.ajax({
				url: $filepath,
				type:'POST',
				cache: false,
				success: function(mtcontent){
					if (mtcontent) {
						if ( $("div[data-mtid='"+ $dfcontent +"']").length > 0 ) {
							// Store content
							$("div[data-mtid='"+ $dfcontent +"']").append(mtcontent);

							// Show content							
							$("div[data-mtid='"+ $dfcontent +"']").contents().clone().appendTo($(e).find(settings.ContentBlock));
							
						}
					}
				}
			});
		}
		else {
			// Show content							
			$("div[data-mtid='"+ $dfcontent +"']").contents().clone().appendTo($(e).find(settings.ContentBlock));
			
		}
		// End Load Defaut Content
		
		

		
		// Enable jScrollpane
		if ( $viewWidth >= 800 ) {

			$scrollapi = $(e).find(settings.ContentBlock).jScrollPane({
				showArrows: false,
				maintainPosition: false,
				autoReinitialise: true
			}).data('jsp');
			
			// Show Scrollbar when mouse hover on contentblock
			$(e).find(settings.ContentBlock).hover(
				function () {
					$(e).find('.jspDrag').addClass(settings.scrollbarstyle);},
				function () {
					$(e).find('.jspDrag').removeClass(settings.scrollbarstyle);}
			);
			
		}
		else {
			$scrollapi == undefined;
			resMedia();
		}
		

		
		
		
		// Window Resize
		function debouncer(func, timeout) {
		   var timeoutID, timeout = timeout || 200;
		   return function() {
			  var scope = this , args = arguments;
			  clearTimeout( timeoutID );
			  timeoutID = setTimeout( function() {
				  func.apply( scope , Array.prototype.slice.call(args));
			  }, timeout);
		   }
		}
		
		// Get IE versoin
		function getInternetExplorerVersion() {
			var rv = -1;
			if (navigator.appName == 'Microsoft Internet Explorer')
			{
				var ua = navigator.userAgent;
				var re  = new RegExp("MSIE ([0-9]{1,}[\.0-9]{0,})");
				if (re.exec(ua) != null)
				rv = parseFloat( RegExp.$1 );
			}
			return rv;
		}
		var $ie_ver = getInternetExplorerVersion();


		if ( $ie_ver<0 || $ie_ver>8 ){
		
		$(window).resize( debouncer( function () {
		
			var $nwWidth = $(window).width();
			if ($viewWidth!=$nwWidth) {
			
				// Reset
				$(e).find('.mt-minibar').remove();
				$(e).find('.mt-blocksholder').css({'display':'none'});
				$(e).find('.mt-contentblock').css({'width':'auto','height':'auto'});
				$(e).find(settings.ContentBlock).css({'width':'auto','height':'auto'});
			
			
				// Destroy Mansory function
				if ( $msr == 1 ) {
					$(e).find('.mt-blocksholder').masonry('destroy');
					$msr = 0;
				}
				
				$(e).find(settings.ContentBlock).find('.jspContainer').find('.jspPane').contents().remove();
				$(e).find(settings.ContentBlock).contents().remove();
				
				$click = 0;
				
				// Remove jScrollpane
				if ( $scrollapi !== undefined ) {
					$scrollapi.destroy();
				}
				
				// Render MetroTabs Plugin
				mtRender();
				
				if ( $viewWidth >= 800 ) {
				
					// Enable jScrollpane if View Width >= 800
					$scrollapi = $(e).find(settings.ContentBlock).jScrollPane({
						showArrows: false,
						maintainPosition: false,
						autoReinitialise: true
					}).data('jsp');
					

					$(e).find(settings.ContentBlock).hover(
						function () {
							$(e).find('.jspDrag').addClass(settings.scrollbarstyle);},
						function () {
							$(e).find('.jspDrag').removeClass(settings.scrollbarstyle);}
					);
					
					// Show content
					$mtcontent = $(e).find('.mt-active').attr('id');
					$("div[data-mtid='"+ $mtcontent +"']").contents().clone().appendTo($(e).find(settings.ContentBlock).find('.jspContainer').find('.jspPane'));
					
				}
				// End view Width >= 800
				else {
					$mtcontent = $(e).find('.mt-active').attr('id');
					$("div[data-mtid='"+ $mtcontent +"']").contents().clone().appendTo($(e).find(settings.ContentBlock));
				}
				
				// Responsive Video
				resMedia();
				
			}
		}));
		}
		// End Resize
		
		
	
	};
	
	$.fn.metrotabs = function(options) {
	
		return this.each(function(key, value){
					
			// Return early if this element already has a plugin instance
            if ($(this).data('metrotabs')) return $(this).data('metrotabs');
			
			// Pass options to plugin constructor
			var metrotabs = new MetroTabs(this, options);
			
			// Store plugin object in this element's data
            $(this).data('metrotabs', metrotabs);
		
		});

	};
	
	//Default settings
	$.fn.metrotabs.defaults = {
		ContentBlock:'.mt-content',
		mtFileExtension: 'php',
		mtEffect: 'vertical', // vertical | horizontal | fade 
		moveout: 'TopOrLeft',
		movein: 'BottomOrRight',
		outeffect:	'easeInBack',
		ineffect: 'easeOutBack',
		outduration: 400,
		induration: 400,
		scrollbarstyle: 'solid-blue', // add background class
		blkwidth: 300,
		minibarbg: 'solid-blue-2',
		minibartitle: '',
	};	
	
})(jQuery);